#if !defined(BaseObject_INCLUDED_)
#define BaseObject_INCLUDED_

#include "Result.h"


/*! \mainpage Welcome to FileSystem DOC
 
	

  \section intro Introduction
  
FileSystem its a set of class to use custom pack files,
giving a transparent use in any apliccation.

This system suport two way of working , object oriented
,and no object oriented, it both case, access to a
compress file inside a packfile, or a real file
in the normal file sytem, you could make
random access to the data, and easily por your
actual code to this one.

You should look at the test project, to see
bot ways of working with this filesystem. And
to see how you could easily use it.

This system dosen't uncompress all the file into
memory, its used a system based on blocks, only
one block at time its actually buffered in memory,
father reades put new data in this buffer, but
dont reallocate memory.


Whith this software as well the are to tools
call , FsPacker and FsUnpacker, after compile
and run onces both of the, they are integreted 
in your windows shell. Rigth click to any folder
to convert to a pack file, double click
to any pack to convert to folders.

This system use zlib for compress the data,
but dont save in zip format, just use
zlib compress/uncompress algorithm.

	\section copyright Copyright
	(c) 2002 \a Juan \a Antonio \a Medina.
 */

namespace FileSystem
{
//!  Base class of all objects. 
/*!
  This class is the base for all objects
*/
class CBaseObject  
{

	public:

		//!  Default constructor. 
		/*!
			Called before the object creation.
		*/
		CBaseObject();

		//!  Default destructor. 
		/*!
			Called before the object destruction.
		*/
		virtual ~CBaseObject();


		//!  Initialize the object. 
		/*!
			This method it's used to initialize the
			object. It should be reimplemented in 
			every descent object.			
			\retval CResult value indicate if initialize was correct.
			\sa finalize()
			\sa CResult()
		*/
		virtual CResult initialize();

		//!  Finalize the object. 
		/*!
			This method it's used to finalize the
			object. It should be reimplemented in 
			every descent object.			
			\retval CResult value indicate if finalize was correct.
			\sa initialize()
			\sa CResult()
		*/
		virtual CResult finalize();


	private:

		//! Indicate if the object has been initializated
		/*!
		    Indicate if the object has been initializated
		*/
		bool initialized;


};
}


#endif // !defined(BaseObject_INCLUDED_)
