// Result.cpp: implementation of the CResult class.
//
//////////////////////////////////////////////////////////////////////


#include "Result.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
namespace FileSystem
{
CResult::CResult(TResultsCode newCode,WORD newSubcode,char* newString)
{
	//init vars
	ZeroMemory(string,sizeof(string));

	code = newCode;
	subcode  = newSubcode;
	strcpy(string,newString);
}

CResult::~CResult()
{

}

CResult::CResult()
{
	//by default ok result
	CResult(codeOk,0,"");
}


CResult resultOk (codeOk,0,"");
CResult resultFail (codeFail,0,"Unknow error");

CResult &CResult::operator = (CResult source)
{
	//copy vars
	code = source.code;
	subcode = source.subcode;
	strcpy(string,source.string);

	return *this;
}

bool operator==(CResult& result1, CResult& result2)
{
	//just compare codes
	return (result1.code == result2.code);
}

bool operator!=(CResult& result1, CResult& result2)
{
	//easy and clean
	return !(result1 == result2);
}
}